#lang scheme

(require redex/reduction-semantics)

(provide apply-reduction-relation/hashed)

(define (apply-reduction-relation/hashed next-steps)
  (let (;; the eq-table holds the actual next steps
        [eq-table (make-hasheq)]
        ;; the equal table is a fallback when the eq-table fails, and
        ;; shows what entry to use in the eq-table
        [equal-table (make-hash)])
    (lambda (term)
      (hash-ref eq-table 
                term
                (lambda ()
                  (cond [(hash-has-key? equal-table term) 
                         (hash-ref eq-table (hash-ref equal-table term))]
                        [else
                         (let ([answers (next-steps term)])
                           (hash-set! eq-table term answers)
                           (hash-set! equal-table term term)
                           (printf "hash table now of size ~v\n" (hash-count eq-table))
                           answers)]))))))

